#include < amxmodx >
#include < amxmisc >
#include < cstrike >

#include < zp_humans >
#include < hamsandwich >
#include < zombieplague >

#define PLUGIN "ZP Class Humans"
#define VERSION "1.0"
#define AUTHOR "OverGame"

#define MAX_SKINS 1000

enum _:udata { zp_hid }
new data [ 33 ][ udata ], hm_Index = -1,
	hm_Items [ MAX_SKINS ][ 255 ], g_fwItemSelected, g_fwDummyResult;

public plugin_init ()
{
	register_plugin ( PLUGIN, VERSION, AUTHOR );
	
	g_fwItemSelected = CreateMultiForward ( "fwd_Select_Human", ET_CONTINUE, FP_CELL, FP_CELL );
}

public plugin_cfg ()
{
	new szCfgDir [ 64 ], szFile [ 192 ];
	get_configsdir ( szCfgDir, charsmax ( szCfgDir ) );
	format ( szFile, charsmax ( szFile ), "%s/zp_class_humans.cfg", szCfgDir );
	
	if ( file_exists ( szFile ) )
		server_cmd ( "exec %s", szFile );
}

public plugin_natives ()
{
	register_native ( "zp_get_user_class_human", "native_get_user_class_human", 1 );
	register_native ( "zp_set_user_class_human", "native_set_user_class_human", 1 );

	register_native ( "zp_add_user_class_human", "native_add_user_class_human", 1 );
	register_native ( "zp_class_human_open", "native_class_human_open", 1 );
}

public native_class_human_open ( id )
	open_menu ( id );

public native_set_user_class_human ( id, hid )
{
	data [ id ][ zp_hid ] = hid;
	ExecuteForward ( g_fwItemSelected, g_fwDummyResult, id, data [ id ][ zp_hid ] );
}

public native_get_user_class_human ( id )
	return data [ id ][ zp_hid ];

public native_add_user_class_human ( const szName [] )
{
	hm_Index++;
	param_convert ( 1 );
	format ( hm_Items [ hm_Index ], charsmax ( hm_Items [] ), "%s", szName );
	
	return hm_Index;
}

public open_menu ( id )
{
	new menu = menu_create ( "\d[ vk.com/plugins_by_overgame ]^n\rКлассы выживших", "func_omenu" );
	
	for ( new i; i <= hm_Index; i++ )
	{
		new szTemp [ 10 ];
		num_to_str ( i, szTemp, charsmax ( szTemp ) );
		menu_additem ( menu, hm_Items [ i ], szTemp, 0 );
	}
	
	menu_setprop ( menu, MPROP_BACKNAME, "Назад" );
	menu_setprop ( menu, MPROP_NEXTNAME, "Далее" );
	menu_setprop ( menu, MPROP_EXITNAME, "Выход" );
	
	menu_display ( id, menu, 0 );
	return PLUGIN_HANDLED;
}

public func_omenu ( id, menu, item )     
{     
	if ( item == MENU_EXIT || zp_get_user_zombie ( id ) ) { menu_destroy ( menu ); return PLUGIN_HANDLED; }
	
	new zdata [ 15 ], iName [ 64 ], access, callback;
	menu_item_getinfo ( menu, item, access, zdata, 15, iName, 64, callback );
	
	new key = str_to_num ( zdata );
	ExecuteForward ( g_fwItemSelected, g_fwDummyResult, id, key );
	
	return PLUGIN_HANDLED;
}