#include < amxmodx >
#include < amxmisc >
#include < cstrike >
#include < fun >

#include < zp_humans >
#include < hamsandwich >
#include < zombieplague >

#define PLUGIN "ZP HClass Fox"
#define VERSION "1.0"
#define AUTHOR "OverGame"

#define REG_NAME "\rДевушка лиса \d[255 жизней,брони]"

new zHash, zFunc [ 33 ];

public plugin_init ()
{
	register_plugin ( PLUGIN, VERSION, AUTHOR );
	
	register_cvar ( "cvar_hclass_fox_health", "255" );
	register_cvar ( "cvar_hclass_fox_armor", "255" );
	
	RegisterHam ( Ham_Spawn, "player", "fwd_HamSpawn" );
	RegisterHam ( Ham_Use, "func_button", "fwd_HamButton", 0 );
	
	zHash = zp_add_user_class_human ( REG_NAME );
}

public plugin_precache ()
	precache_model ( "models/player/hclass_fox/hclass_fox.mdl" );
	
public client_putinserver ( id )
	zFunc [ id ] = true;
	
public fwd_HamButton ( ent, idcaller, idactivator, use_type, Float:value )
{
	if ( is_user_connected ( idactivator ) && is_user_alive ( idactivator ) )
	{
		if ( zp_get_user_class_human ( idactivator ) == zHash )
		{
			if ( zFunc [ idactivator ] ) set_task ( 0.1, "func_class_on", idactivator );
		}
	}
	
	return HAM_IGNORED;
}
	
public fwd_HamSpawn ( id )
{
	if ( is_user_connected ( id ) )
	{
		if ( zp_get_user_class_human ( id ) == zHash )
			func_set_user_class ( id );
	}
}
	
public fwd_Select_Human ( id, hid )
{
	if ( hid == zHash )
	{
		if ( is_user_connected ( id ) || is_user_alive ( id ) )
			func_set_user_class ( id );
	}
}

public func_class_on ( id )
{
	if ( zFunc [ id ] )
	{
		set_user_rendering ( id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 20 );
		zFunc [ id ] = false;
		
		set_task ( 5.0, "func_class_off", id );
	}
}

public func_class_off ( id )
{
	if ( is_user_alive ( id ) )
	{
		set_user_rendering ( id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255 );
		set_task ( 10.0, "func_class_active", id );
	}
}
	
public func_class_active ( id )
	zFunc [ id ] = true;

stock func_set_user_class ( id )
{
	if ( !zp_get_user_zombie ( id ) && is_user_alive ( id ) )
	{
		cs_set_user_model ( id, "hclass_fox" );
		set_user_health ( id, get_cvar_num ( "cvar_hclass_fox_health" ) );
		cs_set_user_armor ( id, get_cvar_num ( "cvar_hclass_fox_armor" ), CS_ARMOR_VESTHELM );
	}
}